/*
 * util.c - pretty printing utility functions
 * (c) 2000 Zeljko Vrba (mordor@fly.srk.fer.hr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "saturn.h"

#ifdef __GNUC__
static char rcsid[] __attribute__((unused)) = "$Id: util.c,v 1.1 2000-01-08 09:24:43+01 zeljko Exp $";
#else
static char rcsid[] = "$Id: util.c,v 1.1 2000-01-08 09:24:43+01 zeljko Exp $";
#endif

/*	Error, warning and pretty-printing functions. */
int indent_level;

void
warning(int line, const char *fmt, ...)
{
	va_list ap;
	fprintf(stderr, "warning: %d: ", line);
	va_start(ap, fmt); vfprintf(stderr, fmt, ap); va_end(ap);
	fprintf(stderr, "\n");
}

void
error(int line, const char *fmt, ...)
{
	va_list ap;
	fprintf(stderr, "error: %d: ", line);
	va_start(ap, fmt); vfprintf(stderr, fmt, ap); va_end(ap);
	fprintf(stderr, "\n");
	exit(1);
}

extern int opt_t;
void
print(FILE *f, const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	if(opt_t) {
		vfprintf(f, fmt, ap);
		fprintf(f, " ");
	} else {
		saturn_print(fmt, ap);
	}
	va_end(ap);
}

void
nl(FILE *f)
{
	if(opt_t) {
		int i;
		fprintf(f, "\n");
		for(i = 0; i < indent_level; i++) fprintf(f, "\t");
	}
}

