#ifndef	__UTIL_H__
#define	__UTIL_H__

#include <stdio.h>


#define	FATAL(x)		\
	{ 					\
		fprintf(stderr,	\
				"internal compiler error %s: %s(%s:%d)\n",	\
				x, __FUNCTION__, __FILE__, __LINE__); \
		abort();		\
	}

#ifdef __GNUC__

void warning(int, const char*, ...) __attribute__((format (printf, 2, 3)));
void error(int, const char*, ...) __attribute__((noreturn, format (printf, 2, 3)));
void print(FILE*, const char*, ...) __attribute__((format (printf, 2, 3)));

#else	/* not __GNUC__ */

void warning(int, const char*, ...);
void error(int, const char*, ...);
void print(FILE*, const char*, ...);

#endif	/* __GNUC__ */

extern int indent_level;
void nl(FILE*);

#endif	/* __UTIL_H__ */

